/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the ExtractionAction type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ExtractionAction{}

// ExtractionAction struct for ExtractionAction
type ExtractionAction struct {
	// Primary key of document. The value is null when document is not persisted.
	Id *string `json:"id,omitempty"`
	// Object ID
	ObjectId interface{} `json:"object_id,omitempty"`
	// Object type
	ObjectType *string `json:"object_type,omitempty"`
	// $type . Type of automated action.
	Type *string `json:"type,omitempty"`
	// Customer ID
	CustomerId *string `json:"customer_id,omitempty"`
	Status     *string `json:"status,omitempty"`
	// Action status detail
	StatusDetail *string `json:"status_detail,omitempty"`
	// Last execution timestamp
	LastMarkInProgress NullableInt32 `json:"last_mark_in_progress,omitempty"`
	// Last execution timestamp
	LastExecution NullableInt32 `json:"last_execution,omitempty"`
	// Last success execution timestamp
	LastSuccessExecution NullableInt32 `json:"last_success_execution,omitempty"`
	// Duration
	Duration NullableString `json:"duration,omitempty"`
	// Error iteration count
	ErrorCount *int32 `json:"error_count,omitempty"`
	// Is the action currently being processed?
	IsBeingProcessed *bool `json:"is_being_processed,omitempty"`
	// Whether it is waiting for the first execution in action's lifetime
	InitialPending *bool `json:"initial_pending,omitempty"`
	// After how many seconds the action should be retried if it is failed. Default is 0 meaning run retry on next Dispatcher's tick.  Example: set to 60*60*2 to retry action not earlier than 2hrs after failure
	OnErrorRetryTimeout *int32 `json:"on_error_retry_timeout,omitempty"`
	// Relations to other actions. By defining this, we can for instance define that some extraction must be run before some write action etc.
	Constraints []interface{} `json:"constraints,omitempty"`
	// Action Schedule settings
	Schedule interface{} `json:"schedule,omitempty"`
	// $request_id
	RequestId *string `json:"request_id,omitempty"`
	// Result
	Result  map[string]interface{} `json:"result,omitempty"`
	Storage *string                `json:"storage,omitempty"`
}

// NewExtractionAction instantiates a new ExtractionAction object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewExtractionAction() *ExtractionAction {
	this := ExtractionAction{}
	return &this
}

// NewExtractionActionWithDefaults instantiates a new ExtractionAction object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewExtractionActionWithDefaults() *ExtractionAction {
	this := ExtractionAction{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *ExtractionAction) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionAction) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *ExtractionAction) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *ExtractionAction) SetId(v string) {
	o.Id = &v
}

// GetObjectId returns the ObjectId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExtractionAction) GetObjectId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.ObjectId
}

// GetObjectIdOk returns a tuple with the ObjectId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExtractionAction) GetObjectIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.ObjectId) {
		return nil, false
	}
	return &o.ObjectId, true
}

// HasObjectId returns a boolean if a field has been set.
func (o *ExtractionAction) HasObjectId() bool {
	if o != nil && IsNil(o.ObjectId) {
		return true
	}

	return false
}

// SetObjectId gets a reference to the given interface{} and assigns it to the ObjectId field.
func (o *ExtractionAction) SetObjectId(v interface{}) {
	o.ObjectId = v
}

// GetObjectType returns the ObjectType field value if set, zero value otherwise.
func (o *ExtractionAction) GetObjectType() string {
	if o == nil || IsNil(o.ObjectType) {
		var ret string
		return ret
	}
	return *o.ObjectType
}

// GetObjectTypeOk returns a tuple with the ObjectType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionAction) GetObjectTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ObjectType) {
		return nil, false
	}
	return o.ObjectType, true
}

// HasObjectType returns a boolean if a field has been set.
func (o *ExtractionAction) HasObjectType() bool {
	if o != nil && !IsNil(o.ObjectType) {
		return true
	}

	return false
}

// SetObjectType gets a reference to the given string and assigns it to the ObjectType field.
func (o *ExtractionAction) SetObjectType(v string) {
	o.ObjectType = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *ExtractionAction) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionAction) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *ExtractionAction) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *ExtractionAction) SetType(v string) {
	o.Type = &v
}

// GetCustomerId returns the CustomerId field value if set, zero value otherwise.
func (o *ExtractionAction) GetCustomerId() string {
	if o == nil || IsNil(o.CustomerId) {
		var ret string
		return ret
	}
	return *o.CustomerId
}

// GetCustomerIdOk returns a tuple with the CustomerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionAction) GetCustomerIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerId) {
		return nil, false
	}
	return o.CustomerId, true
}

// HasCustomerId returns a boolean if a field has been set.
func (o *ExtractionAction) HasCustomerId() bool {
	if o != nil && !IsNil(o.CustomerId) {
		return true
	}

	return false
}

// SetCustomerId gets a reference to the given string and assigns it to the CustomerId field.
func (o *ExtractionAction) SetCustomerId(v string) {
	o.CustomerId = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *ExtractionAction) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionAction) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *ExtractionAction) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *ExtractionAction) SetStatus(v string) {
	o.Status = &v
}

// GetStatusDetail returns the StatusDetail field value if set, zero value otherwise.
func (o *ExtractionAction) GetStatusDetail() string {
	if o == nil || IsNil(o.StatusDetail) {
		var ret string
		return ret
	}
	return *o.StatusDetail
}

// GetStatusDetailOk returns a tuple with the StatusDetail field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionAction) GetStatusDetailOk() (*string, bool) {
	if o == nil || IsNil(o.StatusDetail) {
		return nil, false
	}
	return o.StatusDetail, true
}

// HasStatusDetail returns a boolean if a field has been set.
func (o *ExtractionAction) HasStatusDetail() bool {
	if o != nil && !IsNil(o.StatusDetail) {
		return true
	}

	return false
}

// SetStatusDetail gets a reference to the given string and assigns it to the StatusDetail field.
func (o *ExtractionAction) SetStatusDetail(v string) {
	o.StatusDetail = &v
}

// GetLastMarkInProgress returns the LastMarkInProgress field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExtractionAction) GetLastMarkInProgress() int32 {
	if o == nil || IsNil(o.LastMarkInProgress.Get()) {
		var ret int32
		return ret
	}
	return *o.LastMarkInProgress.Get()
}

// GetLastMarkInProgressOk returns a tuple with the LastMarkInProgress field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExtractionAction) GetLastMarkInProgressOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastMarkInProgress.Get(), o.LastMarkInProgress.IsSet()
}

// HasLastMarkInProgress returns a boolean if a field has been set.
func (o *ExtractionAction) HasLastMarkInProgress() bool {
	if o != nil && o.LastMarkInProgress.IsSet() {
		return true
	}

	return false
}

// SetLastMarkInProgress gets a reference to the given NullableInt32 and assigns it to the LastMarkInProgress field.
func (o *ExtractionAction) SetLastMarkInProgress(v int32) {
	o.LastMarkInProgress.Set(&v)
}

// SetLastMarkInProgressNil sets the value for LastMarkInProgress to be an explicit nil
func (o *ExtractionAction) SetLastMarkInProgressNil() {
	o.LastMarkInProgress.Set(nil)
}

// UnsetLastMarkInProgress ensures that no value is present for LastMarkInProgress, not even an explicit nil
func (o *ExtractionAction) UnsetLastMarkInProgress() {
	o.LastMarkInProgress.Unset()
}

// GetLastExecution returns the LastExecution field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExtractionAction) GetLastExecution() int32 {
	if o == nil || IsNil(o.LastExecution.Get()) {
		var ret int32
		return ret
	}
	return *o.LastExecution.Get()
}

// GetLastExecutionOk returns a tuple with the LastExecution field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExtractionAction) GetLastExecutionOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastExecution.Get(), o.LastExecution.IsSet()
}

// HasLastExecution returns a boolean if a field has been set.
func (o *ExtractionAction) HasLastExecution() bool {
	if o != nil && o.LastExecution.IsSet() {
		return true
	}

	return false
}

// SetLastExecution gets a reference to the given NullableInt32 and assigns it to the LastExecution field.
func (o *ExtractionAction) SetLastExecution(v int32) {
	o.LastExecution.Set(&v)
}

// SetLastExecutionNil sets the value for LastExecution to be an explicit nil
func (o *ExtractionAction) SetLastExecutionNil() {
	o.LastExecution.Set(nil)
}

// UnsetLastExecution ensures that no value is present for LastExecution, not even an explicit nil
func (o *ExtractionAction) UnsetLastExecution() {
	o.LastExecution.Unset()
}

// GetLastSuccessExecution returns the LastSuccessExecution field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExtractionAction) GetLastSuccessExecution() int32 {
	if o == nil || IsNil(o.LastSuccessExecution.Get()) {
		var ret int32
		return ret
	}
	return *o.LastSuccessExecution.Get()
}

// GetLastSuccessExecutionOk returns a tuple with the LastSuccessExecution field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExtractionAction) GetLastSuccessExecutionOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastSuccessExecution.Get(), o.LastSuccessExecution.IsSet()
}

// HasLastSuccessExecution returns a boolean if a field has been set.
func (o *ExtractionAction) HasLastSuccessExecution() bool {
	if o != nil && o.LastSuccessExecution.IsSet() {
		return true
	}

	return false
}

// SetLastSuccessExecution gets a reference to the given NullableInt32 and assigns it to the LastSuccessExecution field.
func (o *ExtractionAction) SetLastSuccessExecution(v int32) {
	o.LastSuccessExecution.Set(&v)
}

// SetLastSuccessExecutionNil sets the value for LastSuccessExecution to be an explicit nil
func (o *ExtractionAction) SetLastSuccessExecutionNil() {
	o.LastSuccessExecution.Set(nil)
}

// UnsetLastSuccessExecution ensures that no value is present for LastSuccessExecution, not even an explicit nil
func (o *ExtractionAction) UnsetLastSuccessExecution() {
	o.LastSuccessExecution.Unset()
}

// GetDuration returns the Duration field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExtractionAction) GetDuration() string {
	if o == nil || IsNil(o.Duration.Get()) {
		var ret string
		return ret
	}
	return *o.Duration.Get()
}

// GetDurationOk returns a tuple with the Duration field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExtractionAction) GetDurationOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Duration.Get(), o.Duration.IsSet()
}

// HasDuration returns a boolean if a field has been set.
func (o *ExtractionAction) HasDuration() bool {
	if o != nil && o.Duration.IsSet() {
		return true
	}

	return false
}

// SetDuration gets a reference to the given NullableString and assigns it to the Duration field.
func (o *ExtractionAction) SetDuration(v string) {
	o.Duration.Set(&v)
}

// SetDurationNil sets the value for Duration to be an explicit nil
func (o *ExtractionAction) SetDurationNil() {
	o.Duration.Set(nil)
}

// UnsetDuration ensures that no value is present for Duration, not even an explicit nil
func (o *ExtractionAction) UnsetDuration() {
	o.Duration.Unset()
}

// GetErrorCount returns the ErrorCount field value if set, zero value otherwise.
func (o *ExtractionAction) GetErrorCount() int32 {
	if o == nil || IsNil(o.ErrorCount) {
		var ret int32
		return ret
	}
	return *o.ErrorCount
}

// GetErrorCountOk returns a tuple with the ErrorCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionAction) GetErrorCountOk() (*int32, bool) {
	if o == nil || IsNil(o.ErrorCount) {
		return nil, false
	}
	return o.ErrorCount, true
}

// HasErrorCount returns a boolean if a field has been set.
func (o *ExtractionAction) HasErrorCount() bool {
	if o != nil && !IsNil(o.ErrorCount) {
		return true
	}

	return false
}

// SetErrorCount gets a reference to the given int32 and assigns it to the ErrorCount field.
func (o *ExtractionAction) SetErrorCount(v int32) {
	o.ErrorCount = &v
}

// GetIsBeingProcessed returns the IsBeingProcessed field value if set, zero value otherwise.
func (o *ExtractionAction) GetIsBeingProcessed() bool {
	if o == nil || IsNil(o.IsBeingProcessed) {
		var ret bool
		return ret
	}
	return *o.IsBeingProcessed
}

// GetIsBeingProcessedOk returns a tuple with the IsBeingProcessed field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionAction) GetIsBeingProcessedOk() (*bool, bool) {
	if o == nil || IsNil(o.IsBeingProcessed) {
		return nil, false
	}
	return o.IsBeingProcessed, true
}

// HasIsBeingProcessed returns a boolean if a field has been set.
func (o *ExtractionAction) HasIsBeingProcessed() bool {
	if o != nil && !IsNil(o.IsBeingProcessed) {
		return true
	}

	return false
}

// SetIsBeingProcessed gets a reference to the given bool and assigns it to the IsBeingProcessed field.
func (o *ExtractionAction) SetIsBeingProcessed(v bool) {
	o.IsBeingProcessed = &v
}

// GetInitialPending returns the InitialPending field value if set, zero value otherwise.
func (o *ExtractionAction) GetInitialPending() bool {
	if o == nil || IsNil(o.InitialPending) {
		var ret bool
		return ret
	}
	return *o.InitialPending
}

// GetInitialPendingOk returns a tuple with the InitialPending field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionAction) GetInitialPendingOk() (*bool, bool) {
	if o == nil || IsNil(o.InitialPending) {
		return nil, false
	}
	return o.InitialPending, true
}

// HasInitialPending returns a boolean if a field has been set.
func (o *ExtractionAction) HasInitialPending() bool {
	if o != nil && !IsNil(o.InitialPending) {
		return true
	}

	return false
}

// SetInitialPending gets a reference to the given bool and assigns it to the InitialPending field.
func (o *ExtractionAction) SetInitialPending(v bool) {
	o.InitialPending = &v
}

// GetOnErrorRetryTimeout returns the OnErrorRetryTimeout field value if set, zero value otherwise.
func (o *ExtractionAction) GetOnErrorRetryTimeout() int32 {
	if o == nil || IsNil(o.OnErrorRetryTimeout) {
		var ret int32
		return ret
	}
	return *o.OnErrorRetryTimeout
}

// GetOnErrorRetryTimeoutOk returns a tuple with the OnErrorRetryTimeout field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionAction) GetOnErrorRetryTimeoutOk() (*int32, bool) {
	if o == nil || IsNil(o.OnErrorRetryTimeout) {
		return nil, false
	}
	return o.OnErrorRetryTimeout, true
}

// HasOnErrorRetryTimeout returns a boolean if a field has been set.
func (o *ExtractionAction) HasOnErrorRetryTimeout() bool {
	if o != nil && !IsNil(o.OnErrorRetryTimeout) {
		return true
	}

	return false
}

// SetOnErrorRetryTimeout gets a reference to the given int32 and assigns it to the OnErrorRetryTimeout field.
func (o *ExtractionAction) SetOnErrorRetryTimeout(v int32) {
	o.OnErrorRetryTimeout = &v
}

// GetConstraints returns the Constraints field value if set, zero value otherwise.
func (o *ExtractionAction) GetConstraints() []interface{} {
	if o == nil || IsNil(o.Constraints) {
		var ret []interface{}
		return ret
	}
	return o.Constraints
}

// GetConstraintsOk returns a tuple with the Constraints field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionAction) GetConstraintsOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Constraints) {
		return nil, false
	}
	return o.Constraints, true
}

// HasConstraints returns a boolean if a field has been set.
func (o *ExtractionAction) HasConstraints() bool {
	if o != nil && !IsNil(o.Constraints) {
		return true
	}

	return false
}

// SetConstraints gets a reference to the given []interface{} and assigns it to the Constraints field.
func (o *ExtractionAction) SetConstraints(v []interface{}) {
	o.Constraints = v
}

// GetSchedule returns the Schedule field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExtractionAction) GetSchedule() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Schedule
}

// GetScheduleOk returns a tuple with the Schedule field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExtractionAction) GetScheduleOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Schedule) {
		return nil, false
	}
	return &o.Schedule, true
}

// HasSchedule returns a boolean if a field has been set.
func (o *ExtractionAction) HasSchedule() bool {
	if o != nil && IsNil(o.Schedule) {
		return true
	}

	return false
}

// SetSchedule gets a reference to the given interface{} and assigns it to the Schedule field.
func (o *ExtractionAction) SetSchedule(v interface{}) {
	o.Schedule = v
}

// GetRequestId returns the RequestId field value if set, zero value otherwise.
func (o *ExtractionAction) GetRequestId() string {
	if o == nil || IsNil(o.RequestId) {
		var ret string
		return ret
	}
	return *o.RequestId
}

// GetRequestIdOk returns a tuple with the RequestId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionAction) GetRequestIdOk() (*string, bool) {
	if o == nil || IsNil(o.RequestId) {
		return nil, false
	}
	return o.RequestId, true
}

// HasRequestId returns a boolean if a field has been set.
func (o *ExtractionAction) HasRequestId() bool {
	if o != nil && !IsNil(o.RequestId) {
		return true
	}

	return false
}

// SetRequestId gets a reference to the given string and assigns it to the RequestId field.
func (o *ExtractionAction) SetRequestId(v string) {
	o.RequestId = &v
}

// GetResult returns the Result field value if set, zero value otherwise.
func (o *ExtractionAction) GetResult() map[string]interface{} {
	if o == nil || IsNil(o.Result) {
		var ret map[string]interface{}
		return ret
	}
	return o.Result
}

// GetResultOk returns a tuple with the Result field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionAction) GetResultOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Result) {
		return map[string]interface{}{}, false
	}
	return o.Result, true
}

// HasResult returns a boolean if a field has been set.
func (o *ExtractionAction) HasResult() bool {
	if o != nil && !IsNil(o.Result) {
		return true
	}

	return false
}

// SetResult gets a reference to the given map[string]interface{} and assigns it to the Result field.
func (o *ExtractionAction) SetResult(v map[string]interface{}) {
	o.Result = v
}

// GetStorage returns the Storage field value if set, zero value otherwise.
func (o *ExtractionAction) GetStorage() string {
	if o == nil || IsNil(o.Storage) {
		var ret string
		return ret
	}
	return *o.Storage
}

// GetStorageOk returns a tuple with the Storage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionAction) GetStorageOk() (*string, bool) {
	if o == nil || IsNil(o.Storage) {
		return nil, false
	}
	return o.Storage, true
}

// HasStorage returns a boolean if a field has been set.
func (o *ExtractionAction) HasStorage() bool {
	if o != nil && !IsNil(o.Storage) {
		return true
	}

	return false
}

// SetStorage gets a reference to the given string and assigns it to the Storage field.
func (o *ExtractionAction) SetStorage(v string) {
	o.Storage = &v
}

func (o ExtractionAction) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ExtractionAction) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if o.ObjectId != nil {
		toSerialize["object_id"] = o.ObjectId
	}
	if !IsNil(o.ObjectType) {
		toSerialize["object_type"] = o.ObjectType
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.CustomerId) {
		toSerialize["customer_id"] = o.CustomerId
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.StatusDetail) {
		toSerialize["status_detail"] = o.StatusDetail
	}
	if o.LastMarkInProgress.IsSet() {
		toSerialize["last_mark_in_progress"] = o.LastMarkInProgress.Get()
	}
	if o.LastExecution.IsSet() {
		toSerialize["last_execution"] = o.LastExecution.Get()
	}
	if o.LastSuccessExecution.IsSet() {
		toSerialize["last_success_execution"] = o.LastSuccessExecution.Get()
	}
	if o.Duration.IsSet() {
		toSerialize["duration"] = o.Duration.Get()
	}
	if !IsNil(o.ErrorCount) {
		toSerialize["error_count"] = o.ErrorCount
	}
	if !IsNil(o.IsBeingProcessed) {
		toSerialize["is_being_processed"] = o.IsBeingProcessed
	}
	if !IsNil(o.InitialPending) {
		toSerialize["initial_pending"] = o.InitialPending
	}
	if !IsNil(o.OnErrorRetryTimeout) {
		toSerialize["on_error_retry_timeout"] = o.OnErrorRetryTimeout
	}
	if !IsNil(o.Constraints) {
		toSerialize["constraints"] = o.Constraints
	}
	if o.Schedule != nil {
		toSerialize["schedule"] = o.Schedule
	}
	if !IsNil(o.RequestId) {
		toSerialize["request_id"] = o.RequestId
	}
	if !IsNil(o.Result) {
		toSerialize["result"] = o.Result
	}
	if !IsNil(o.Storage) {
		toSerialize["storage"] = o.Storage
	}
	return toSerialize, nil
}

type NullableExtractionAction struct {
	value *ExtractionAction
	isSet bool
}

func (v NullableExtractionAction) Get() *ExtractionAction {
	return v.value
}

func (v *NullableExtractionAction) Set(val *ExtractionAction) {
	v.value = val
	v.isSet = true
}

func (v NullableExtractionAction) IsSet() bool {
	return v.isSet
}

func (v *NullableExtractionAction) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableExtractionAction(val *ExtractionAction) *NullableExtractionAction {
	return &NullableExtractionAction{value: val, isSet: true}
}

func (v NullableExtractionAction) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableExtractionAction) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
